{{
  This object provide file I/O functions for SpinSim.  It currently implements only popen, pclose and pread.
  The methods a similar to the ones the FSRW object. A dummy mount routine is provide for compatibility.
}}
con
  SYS_COMMAND = $7ff8
  SYS_PARM    = $7ffc

  SYS_FILE_OPEN     = 3
  SYS_FILE_CLOSE    = 4
  SYS_FILE_READ     = 5

dat
  handle long 0

pub mount(pin)

pub popen(fname, mode) | parms[2]
  pclose
  parms[0] := fname
  if mode == "R"
    parms[1] := string("rb")
  elseif mode == "W"
    parms[1] := string("wb")
  elseif mode == "A"
    parms[1] := string("ab")
  else
    return 0
  long[SYS_PARM] := @parms
  long[SYS_COMMAND] := SYS_FILE_OPEN
  repeat while long[SYS_COMMAND]
  handle := long[SYS_PARM]
  ifnot handle
    return -1

pub pclose
  ifnot handle
    return -1
  long[SYS_PARM] := handle
  long[SYS_COMMAND] := SYS_FILE_CLOSE
  repeat while long[SYS_COMMAND]
  handle~
    
pub pread(buffer, num)
  ifnot handle
    return -1
  long[SYS_PARM] := @buffer
  long[SYS_COMMAND] := SYS_FILE_READ
  repeat while long[SYS_COMMAND]
  return long[SYS_PARM]
  
  